--- FL/Enumerations.H.original	2008-08-15 18:11:21.000000000 -0300
+++ FL/Enumerations.H	2008-09-11 14:19:43.000000000 -0300
@@ -287,7 +287,14 @@
    *  If the widget returns 1, it will receive the data in the immediatly 
    *  following FL_PASTE event.
    */
-  FL_DND_RELEASE	= 23
+  FL_DND_RELEASE	= 23,
+
+
+  /** The mouse has hovered over a widget causing a tooltip to appear. 
+   *  If the widget has a tooltip, even an empty string, it will
+   *  receive this event prior to displaying the tooltip.
+   */
+  FL_TOOLTIP        = 24
 };
 
 enum Fl_When { // Fl_Widget::when():
--- src/Fl_Tooltip.cxx.original	2008-08-15 18:11:21.000000000 -0300
+++ src/Fl_Tooltip.cxx	2008-09-11 16:35:56.000000000 -0300
@@ -153,7 +153,7 @@
   for (;;) {
     if (!tw) {exit_(0); return;}
     if (tw == widget_) return;
-    if (tw->tooltip()) break;
+    if (tw->tooltip()) {tw->handle(FL_TOOLTIP); break;}
     tw = tw->parent();
   }
   enter_area(w, 0, 0, w->w(), w->h(), tw->tooltip());
